3 # Copyright (c) 2005 Junio C Hamano
6 USAGE='[-n] [--no-commit] [--squash] [-s <strategy>] [-m=<merge-message>] <commit>+'
13 test -z "$(git ls-files -u)" ||
14 die "You are in the middle of a conflicted merge."
19 all_strategies='recur recursive octopus resolve stupid ours subtree'
20 default_twohead_strategies='recursive'
21 default_octopus_strategies='octopus'
22 no_trivial_merge_strategies='ours subtree'
28 rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
29 "$GIT_DIR/MERGE_SAVE" || exit 1
33 # Stash away any local modifications.
34 git-diff-index -z --name-only $head |
35 cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
39 if test -f "$GIT_DIR/MERGE_SAVE"
41 git reset --hard $head >/dev/null
42 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
43 git-update-index --refresh >/dev/null
47 finish_up_to_date () {
50 echo "$1 (nothing to squash)" ;;
58 echo Squashed commit of the following:
60 git-log --no-merges ^"$head" $remote
66 rlogm="$GIT_REFLOG_ACTION"
69 rlogm="$GIT_REFLOG_ACTION: $2"
73 echo "Squash commit -- not updating HEAD"
74 squash_message >"$GIT_DIR/SQUASH_MSG"
79 echo "No merge message -- not updating HEAD"
82 git-update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
93 # We want color (if set), but no pager
94 GIT_PAGER='' git-diff --stat --summary -M "$head" "$1"
103 rh=$(git-rev-parse --verify "$remote^0" 2>/dev/null) || return
104 bh=$(git-show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
105 if test "$rh" = "$bh"
107 echo "$rh branch '$remote' of ."
108 elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
109 git-show-ref -q --verify "refs/heads/$truname" 2>/dev/null
111 echo "$rh branch '$truname' (early part) of ."
112 elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
114 sed -e 's/ not-for-merge / /' -e 1q \
115 "$GIT_DIR/FETCH_HEAD"
117 echo "$rh commit '$remote'"
121 case "$#" in 0) usage ;; esac
124 while case "$#" in 0) break ;; esac
127 -n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
128 --no-summa|--no-summar|--no-summary)
130 --sq|--squ|--squa|--squas|--squash)
131 squash=t no_commit=t ;;
132 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
134 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
135 --strateg=*|--strategy=*|\
136 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
139 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
146 case " $all_strategies " in
148 use_strategies="$use_strategies$strategy " ;;
150 die "available strategies are: $all_strategies" ;;
153 -m=*|--m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
154 merge_msg=`expr "z$1" : 'z-[^=]*=\(.*\)'`
157 -m|--m|--me|--mes|--mess|--messa|--messag|--message)
171 # This could be traditional "merge <msg> HEAD <commit>..." and the
172 # way we can tell it is to see if the second token is HEAD, but some
173 # people might have misused the interface and used a committish that
174 # is the same as HEAD there instead. Traditional format never would
175 # have "-m" so it is an additional safety measure to check for it.
177 if test -z "$have_message" &&
178 second_token=$(git-rev-parse --verify "$2^0" 2>/dev/null) &&
179 head_commit=$(git-rev-parse --verify "HEAD" 2>/dev/null) &&
180 test "$second_token" = "$head_commit"
186 elif ! git-rev-parse --verify HEAD >/dev/null 2>&1
188 # If the merged head is a valid one there is no reason to
189 # forbid "git merge" into a branch yet to be born. We do
190 # the same for "git pull".
193 echo >&2 "Can merge only exactly one commit into empty head"
197 rh=$(git rev-parse --verify "$1^0") ||
198 die "$1 - not something we can merge"
200 git-update-ref -m "initial pull" HEAD "$rh" "" &&
201 git-read-tree --reset -u HEAD
205 # We are invoked directly as the first-class UI.
208 # All the rest are the commits being merged; prepare
209 # the standard merge summary message to be appended to
210 # the given message. If remote is invalid we will die
211 # later in the common codepath so we discard the error
213 merge_name=$(for remote
216 done | git-fmt-merge-msg
218 merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
220 head=$(git-rev-parse --verify "$head_arg"^0) || usage
222 # All the rest are remote heads
223 test "$#" = 0 && usage ;# we need at least one remote head.
224 set_reflog_action "merge $*"
229 remotehead=$(git-rev-parse --verify "$remote"^0 2>/dev/null) ||
230 die "$remote - not something we can merge"
231 remoteheads="${remoteheads}$remotehead "
232 eval GITHEAD_$remotehead='"$remote"'
233 export GITHEAD_$remotehead
235 set x $remoteheads ; shift
237 case "$use_strategies" in
241 var="`git-config --get pull.twohead`"
244 use_strategies="$var"
246 use_strategies="$default_twohead_strategies"
249 var="`git-config --get pull.octopus`"
252 use_strategies="$var"
254 use_strategies="$default_octopus_strategies"
260 for s in $use_strategies
262 for nt in $no_trivial_merge_strategies
275 common=$(git-merge-base --all $head "$@")
278 common=$(git-show-branch --merge-base $head "$@")
281 echo "$head" >"$GIT_DIR/ORIG_HEAD"
283 case "$index_merge,$#,$common,$no_commit" in
285 # We've been told not to try anything clever. Skip to real merge.
288 # No common ancestors found. We need a real merge.
291 # If head can reach all the merge then we are up to date.
292 # but first the most common case of merging one remote.
293 finish_up_to_date "Already up-to-date."
297 # Again the most common case of merging one remote.
298 echo "Updating $(git-rev-parse --short $head)..$(git-rev-parse --short $1)"
299 git-update-index --refresh 2>/dev/null
301 if test -n "$have_message"
303 msg="$msg (no commit created; -m option ignored)"
305 new_head=$(git-rev-parse --verify "$1^0") &&
306 git-read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
307 finish "$new_head" "$msg" || exit
312 # We are not doing octopus and not fast forward. Need a
316 # We are not doing octopus, not fast forward, and have only
318 git-update-index --refresh 2>/dev/null
319 case " $use_strategies " in
320 *' recursive '*|*' recur '*)
324 # See if it is really trivial.
325 git var GIT_COMMITTER_IDENT >/dev/null || exit
326 echo "Trying really trivial in-index merge..."
327 if git-read-tree --trivial -m -u -v $common $head "$1" &&
328 result_tree=$(git-write-tree)
333 git-commit-tree $result_tree -p HEAD -p "$1"
335 finish "$result_commit" "In-index merge"
343 # An octopus. If we can reach all the remote we are up to date.
347 common_one=$(git-merge-base --all $head $remote)
348 if test "$common_one" != "$remote"
354 if test "$up_to_date" = t
356 finish_up_to_date "Already up-to-date. Yeeah!"
362 # We are going to make a new commit.
363 git var GIT_COMMITTER_IDENT >/dev/null || exit
365 # At this point, we need a real merge. No matter what strategy
366 # we use, it would operate on the index, possibly affecting the
367 # working tree, and when resolved cleanly, have the desired tree
368 # in the index -- this means that the index must be in sync with
369 # the $head commit. The strategies are responsible to ensure this.
371 case "$use_strategies" in
373 # Stash away the local changes so that we can try more than one.
378 rm -f "$GIT_DIR/MERGE_SAVE"
383 result_tree= best_cnt=-1 best_strategy= wt_strategy=
385 for strategy in $use_strategies
387 test "$wt_strategy" = '' || {
388 echo "Rewinding the tree to pristine..."
391 case "$single_strategy" in
393 echo "Trying merge strategy $strategy..."
397 # Remember which strategy left the state in the working tree
398 wt_strategy=$strategy
400 git-merge-$strategy $common -- "$head_arg" "$@"
402 if test "$no_commit" = t && test "$exit" = 0
405 exit=1 ;# pretend it left conflicts.
408 test "$exit" = 0 || {
410 # The backend exits with 1 when conflicts are left to be resolved,
411 # with 2 when it does not handle the given merge at all.
413 if test "$exit" -eq 1
416 git-diff-files --name-only
417 git-ls-files --unmerged
419 if test $best_cnt -le 0 -o $cnt -le $best_cnt
421 best_strategy=$strategy
428 # Automerge succeeded.
429 result_tree=$(git-write-tree) && break
432 # If we have a resulting tree, that means the strategy module
433 # auto resolved the merge cleanly.
434 if test '' != "$result_tree"
436 parents=$(git-show-branch --independent "$head" "$@" | sed -e 's/^/-p /')
437 result_commit=$(echo "$merge_msg" | git-commit-tree $result_tree $parents) || exit
438 finish "$result_commit" "Merge made by $wt_strategy."
443 # Pick the result from the best strategy and have the user fix it up.
444 case "$best_strategy" in
447 case "$use_strategies" in
449 echo >&2 "No merge strategy handled the merge."
452 echo >&2 "Merge with strategy $use_strategies failed."
458 # We already have its result in the working tree.
461 echo "Rewinding the tree to pristine..."
463 echo "Using the $best_strategy to prepare resolving by hand."
464 git-merge-$best_strategy $common -- "$head_arg" "$@"
468 if test "$squash" = t
475 done >"$GIT_DIR/MERGE_HEAD"
476 echo "$merge_msg" >"$GIT_DIR/MERGE_MSG"
479 if test "$merge_was_ok" = t
482 "Automatic merge went well; stopped before committing as requested"
489 git ls-files --unmerged |
490 sed -e 's/^[^ ]* / /' |
492 } >>"$GIT_DIR/MERGE_MSG"
493 if test -d "$GIT_DIR/rr-cache"
497 die "Automatic merge failed; fix conflicts and then commit the result."